FSCK.FAT(8)

BEZEICHNUNG
fsck.fat - MS-DOS-FAT-Dateisysteme überprüfen und reparieren

ÜBERSICHT
fsck.fat [OPTIONEN] GERÄT

BESCHREIBUNG
fsck.fat überprüft die Konsistenz von MS-DOS-Dateisystemen und versucht optional, diese zu reparieren.

Die folgenden Dateisystemprobleme können korrigiert werden (in dieser Reihenfolge):

•   Die Dateizuweisungstabelle (FAT) enthält ungültige Cluster-Nummern. Die Cluster werden zu EOF (Dateiende) geändert.

•   Die Kette der Datei-Cluster enthält eine Schleife. Die Schleife ist unterbrochen.

•   Fehlerhafte Cluster (Lesefehler). Die Cluster werden als fehlerhaft markiert und von den Dateien entfernt, denen sie gehören. Diese Überprüfung ist optional.

•   Die Verzeichnisse mit einer großen Anzahl fehlerhafter Einträge (wahrscheinlich beschädigt). Das Verzeichnis kann gelöscht werden.

•   Die Dateien . und .. sind keine Verzeichnisse. Diese können gelöscht oder umbenannt werden.

•   Die Verzeichnisse . und .. im Wurzelverzeichnis. Diese werden gelöscht.

•   Fehlerhafte Dateinamen. Diese können umbenannt werden.

•   Doppelte Verzeichniseinträge. Diese können gelöscht oder umbenannt werden.

•   Die Verzeichnisse mit einem Größenfeld eines von 0 verschiedenen Werts. Die Größe wird auf 0 gesetzt.

•   Das Verzeichnis . zeigt nicht auf das Elternverzeichnis. Der Startzeiger wird angepasst.

•   Das Verzeichnis .. zeigt nicht auf den Elterneintrag des Elternverzeichnisses. Der Startzeiger wird angepasst.

•   . und .. sind in einem Nicht-Wurzelverzeichnis nicht die ersten beiden Einträge. Die Einträge werden erstellt, wobei belegte Slots bei Bedarf verschoben werden.

•   Die Nummer des Start-Clusters einer Datei ist ungültig. Die Datei wird abgeschnitten.

•   Die Datei enthält fehlerhafte oder freie Cluster. Die Datei wird abgeschnitten.

•   Die Kette der Datei-Cluster ist länger als durch die Größenfelder angezeigt wird. Die Datei wird abgeschnitten.

•   Zwei oder mehr Dateien teilen einen oder mehrere Cluster. Alle Dateien bis auf eine werden abgeschnitten. Falls die abzuschneidende Datei ein Verzeichnis ist, das schon gelesen wurde, wird die Dateisystemüberprüfung nach dem Abschneiden neu gestartet.

•   Die Kette der Datei-Cluster ist kürzer als durch die Größenfelder angezeigt wird. Die Datei wird abgeschnitten.

•   Die Datenträgerbezeichnung im Wurzelverzeichnis oder die Bezeichnung im Bootsektor ist ungültig. Ungültige Bezeichnungen werden entfernt.

•   Die Datenträgerbezeichnung im Wurzelverzeichnis und die Bezeichnung im Bootsektor sind unterschiedlich. Die Datenträgerbezeichnung im Wurzelverzeichnis wird in den Bootsektor kopiert.

•   Die Cluster sind als benutzt markiert, aber gehören zu keiner Datei. Sie werden als frei markiert.

Zusätzlich werden die folgenden Probleme zwar erkannt, aber nicht repariert:

•   Ungültige Parameter im Bootsektor

Wenn fsck.fat ein Dateisystem überprüft, sammelt es alle Änderungen im Speicher und führt sie erst aus, nachdem alle Überprüfungen abgeschlossen sind. Dies kann mit der Option -w deaktiviert werden.

Zwei verschiedene Varianten des FAT-Dateisystems werden unterstützt. Per Vorgabe werden die die von Microsoft definierten Dateisysteme FAT12, FAT16 und FAT32 unterstützt, die häufig auf Festplatten und Wechseldatenträgern wie USB-Sticks und SD-Karten verwendet werden. Die zweite unterstützte Variante ist die auf dem Atari ST verwendete klassische Atari-Variante.

Es gibt einige kleine Unterschiede bei der Verwendung des Atari-Formats: Einige Bootsektor-Felder werden etwas anders interpretiert und die speziellen FAT-Einträge für EOF (Dateiende) und fehlerhafte Cluster können unterschiedlich sein. Unter MS-DOS wird 0xfff8 für EOF verwendet, unter Atari dagegen standardmäßig 0xffff, aber beide Systeme erkennen alle Werte von 0xfff8 bis 0xffff als EOF an. MS-DOS verwendet nur 0xfff7 für fehlerhafte Cluster, während unter Atari Werte von 0xfff0 bis 0xfff7 diesem Zweck dienen (wobei der Standardwert weiterhin 0xfff7 ist).

OPTIONEN

-a  repariert das Dateisystem automatisch. Es ist kein Benutzereingriff erforderlich. Wann immer es mehr als eine Methode zur Lösung eines Problems gibt, wird die am wenigsten zerstörerische Methode gewählt.

-A  Wählen Sie die Atari-Variante des FAT-Dateisystems, falls diese nicht bereits aktiv ist, anderenfalls wählen Sie das Standard-FAT-Dateisystem. Die Atari-Variante wird standardmäßig ausgewählt, wenn Sie mkfs.fat auf einem 68k Atari Linux ausführen.

-b  führt eine Überprüfung des Bootsektors aus (nur mit Lesezugriff).

-c TABELLE
    verwendet die angegebene DOS-Zeichensatz-TABELLE zum Dekodieren kurzer Dateinamen. Standardmäßig wird die Zeichensatztabelle 850 verwendet.

-d PFAD
    löscht die angegebene Datei. Falls mehrere Dateien dieses Namens existieren, wird die erste gelöscht. Diese Option kann mehrfach angegeben werden.

-f  rettet ungenutzte Cluster-Ketten in Dateien. Standardmäßig werden ungenutzte Cluster zum freien Plattenplatz hinzugefügt, außer im automatischen Modus (-a).

-F NUMMER
    gibt die FAT-Tabelle NUMMER für den Dateisystemzugriff an. Als Standardwert wird 0 angenommen und dann die erste unbeschädigte FAT-Tabelle gewählt. Unbeschädigt bedeutet, dass die FAT-Tabelle einen gültigen ersten Cluster hat. Falls der Standardwert 0 verwendet wird und alle FAT-Tabellen beschädigt sind, dann gibt fsck.fat auf und unternimmt keinen Versuch, das Dateisystem zu reparieren. Falls als NUMMER ein von 0 verschiedener Wert angegeben wird, dann verwendet fsck.fat die FAT-Tabelle mit dieser NUMMER für die Reparatur des Dateisystems. Falls der erste Cluster der FAT-Tabelle mit der angegebenen NUMMER beschädigt ist, wird fsck.fat ihn reparieren. In jedem Fall wird der reparierte Inhalt der gewählten FAT-Tabelle in andere FAT-Tabellen kopiert, sofern das FAT-Dateisystem mehrere FAT-Tabellen hat. Um einen beschädigten ersten Cluster reparieren zu können, muss fsck.fat mit einer von 0 verschiedenen NUMMER aufgerufen werden.

-l  listet die Pfadnamen der verarbeiteten Dateien auf.

-n  aktiviert den »aktionslosen« Modus: Es wird nicht-interaktiv auf Fehler überprüft, aber nichts ins Dateisystem geschrieben.

-p  ist gleichbedeutend mit -a, zwecks Kompatibilität zu anderen *fsck-Programmen.

-r  repariert das Dateisystem interaktiv. Der Benutzer wird immer dann um eine Entscheidung gebeten, wenn es mehr als einen Ansatz zur Beseitigung einer Inkonsistenz gibt. Dies ist der Vorgabemodus. Die Option wird nur zwecks Abwärtskompatibilität beibehalten.

-S  betrachtet kurze Dateinamen (8.3) mit Leerzeichen in der Mitte als unzulässig, wie es bereits frühere Versionen dieses Programms taten. Zwar sind solche Dateinamen laut FAT-Spezifikation nicht verboten und wurden von den Microsoft-Werkzeugen zur Dateisystemüberprüfung nie als Fehler aufgefasst, aber viele DOS-Programme können mit Dateien mit solchen Namen nicht umgehen. Mit dieser Option können Sie dafür sorgen, dass sie für diese Programme zugänglich werden.

    Kurze Dateinamen, die mit einem Leerzeichen beginnen, werden unabhängig von dieser Einstellung als ungültig betrachtet.

    Frühere Versionen dieses Programms betrachteten EA DATA. SF und WP ROOT. SF ausnahmsweise als zulässige Kurznamen; durch die Verwendung dieser Option wird diese Ausnahme nicht beibehalten.

-t  markiert unlesbare Cluster als fehlerhaft.

-u PFAD
    versucht, das Löschen der angegebenen Datei rückgängig zu machen. fsck.fat versucht, eine Kette zusammenhängender, nicht zugewiesener Cluster beginnend beim Start-Cluster der wiederhergestellten Datei zuzuweisen. Diese Option kann mehrfach angegeben werden.

-U  betrachtet Datenträger- und Boot-Bezeichnungen in Kleinschreibung als ungültig und erlaubt nur Großbuchstaben. Solche Bezeichnungen sind in der FAT-Spezifikation verboten, sind aber bei Linux-Werkzeugen weit verbreitet. Außerdem können MS-DOS- und Windows-Systeme diese Bezeichnungen problemlos lesen. Daher sind Datenträger- und Boot-Bezeichnungen in Kleinschreibung standardmäßig erlaubt.

-v  aktiviert den ausführlichen Modus, in dem etwas mehr Ausgaben erzeugt werden.

-V  führt einen Überprüfungsdurchlauf aus. Die Dateisystemüberprüfung wird nach dem ersten Durchlauf wiederholt. Der zweite Durchlauf sollte niemals irgendwelche korrigierbaren Fehler melden. Er kann wesentlich länger als der erste Durchlauf dauern, da der erste Durchlauf eine lange Änderungsliste erstellt haben könnte, die für jedes Lesen der Platte ausgewertet werden muss.

--variant TYP
    erstellt ein Dateisystem des angegebenen TYPS. Zulässige Werte sind standard und atari (in beliebiger Kombination aus Groß- und Kleinschreibung). Die Unterschiede sind in der vorstehenden BESCHREIBUNG erklärt.

-w  schreibt die Änderungen unmittelbar auf die Platte.

-y  ist gleichbedeutend mit -a (automatische Reparatur des Dateisystems), zwecks Kompatibilität zu anderen *fsck-Programmen.

--help
    zeigt eine Hilfemeldung an, welche die Verwendung und die Optionen beschreibt, und beendet das Programm.

EXIT-STATUS

0   Es wurden keine korrigierbaren Fehler entdeckt.

1   Es wurden korrigierbare Fehler entdeckt oder fsck.fat hat eine interne Inkonsistenz erkannt.

2   Benutzerfehler. fsck.fat hat nicht auf das Dateisystem zugegriffen.

DATEIEN

fsck0000.rec, fsck0001.rec, …
    Beim Reparieren eines beschädigten Dateisystems schreibt fsck.fat die wiederhergestellten Daten in Dateien namens fsckNNNN.rec in das Verzeichnis der obersten Ebene des Dateisystems.

FEHLER

•   Nicht vollständig leere Verzeichnisse werden nicht entfernt.

•   Es sollten mehr Diagnosemeldungen ausgegeben werden.

•   Beim Wiederherstellen von Dateien sollte ein ausgefeilterer Algorithmus verwendet werden.

SIEHE AUCH
fatlabel(8), mkfs.fat(8)

HOMEPAGE
Die Heimat des Projekts dosfstools ist seine GitHub-Projektseite (https://github.com/dosfstools/dosfstools).

AUTOREN
dosfstools wurde von Werner Almesberger (werner.almesberger@lrc.di.epfl.ch), , Roman Hodek und anderen geschrieben. Die aktuellen Betreuer sind Andreas Bombe (aeb@debian.org) und Pali Rohár (pali.rohar@gmail.com).

ÜBERSETZUNG
Die deutsche Übersetzung dieser Handbuchseite wurde von Mario Blättermann <mario.blaettermann@gmail.com> erstellt.

Diese Übersetzung ist Freie Dokumentation; lesen Sie die GNU General Public License Version 3 (https://www.gnu.org/licenses/gpl-3.0.html) oder neuer bezüglich der Copyright-Bedingungen. Es wird KEINE HAFTUNG übernommen.

Wenn Sie Fehler in der Übersetzung dieser Handbuchseite finden, schicken Sie bitte eine E-Mail an die Mailingliste der Übersetzer (debian-l10n-german@lists.debian.org).